#include "lcd.h"
#include "stdlib.h"
#include "usart.h"
#include "delay.h"	


#define ROW  160			//ʾ
#define COL  128			//ʾ	   

//ɫ,ɫ
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF;  
u16 DeviceCode;	   
//===================================================================================================
/* : void LCD_WR_REG(u16 data)
   :  дĴ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================
void LCD_WR_REG(u16 data)
{ 
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_CLR;
	DATAOUT(data);
	LCD_WR_CLR;
	LCD_WR_SET;
//	DATAOUT(data);
//	LCD_WR_CLR;
//	LCD_WR_SET;
//	LCD_CS_SET;
}

//===================================================================================================
/* : void LCD_WR_DATA(u16 data)
   :  д
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================
void LCD_WR_DATA(u16 data)
{
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;
	
	DATAOUT(data);
	LCD_WR_CLR;
	LCD_WR_SET;
//	DATAOUT(data);
//	LCD_WR_CLR;
//	LCD_WR_SET;
//	LCD_CS_SET;
}


void WriteOneDot(unsigned int color)
{
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;
	
	DATAOUT(color);
	LCD_WR_CLR;
	LCD_WR_SET;
//	DATAOUT(data);
//	LCD_WR_CLR;
//	LCD_WR_SET;
//	LCD_CS_SET;
}


//===================================================================================================
/* : void LCD_CtrlWrite_ILI9326(u16 reg_addr, u16 reg_data)
   :  ԼĴдݣʼLCD
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================

void LCD_CtrlWrite_ILI9326(u16 reg_addr, u16 reg_data)
{
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_CLR;
	
//	DATAOUT(reg_addr>>8);
//	LCD_WR_CLR;
//	LCD_WR_SET;
	
	DATAOUT(reg_addr);
	LCD_WR_CLR;
	LCD_WR_SET;
	
	LCD_CS_SET;
	
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;
	
//	DATAOUT(reg_data>>8);
//	LCD_WR_CLR;
//	LCD_WR_SET;
	
	DATAOUT(reg_data);
	LCD_WR_CLR;
	LCD_WR_SET;
	LCD_CS_SET;
}


void read_reg(unsigned short reg)
{
	unsigned char value_h,value_m,value_l;
	

	LCD_WR_REG(reg);
	
	GPIOB->CRL=0X88888888; //PB0-7  
	LCD_CS_CLR;
	LCD_WR_SET;
	LCD_RS_SET;
	
	
	LCD_RD_CLR;
	delay_us(2);
	LCD_RD_SET;
	value_h=DATAIN;
	

	LCD_RD_CLR;
	delay_us(2);
	LCD_RD_SET;
	value_h=DATAIN;
	
		LCD_RD_CLR;
	  LCD_RD_SET;
	value_m=DATAIN;
	

	LCD_RD_CLR;
	LCD_RD_SET;
	value_l=DATAIN;
//	
	
	LCD_CS_SET;
GPIOB->CRL=0X33333333; //PB0-7  
	printf("reg=%2x %2x %2x\n\r",value_h,value_m,value_l);
	
	
}
//===================================================================================================
/* : void LCD_GPIOInit(void)
   :  LCD صGPIO趨
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================

void LCD_GPIOInit(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOD|RCC_APB2Periph_AFIO, ENABLE); //B
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5|GPIO_Pin_4|GPIO_Pin_3;	   //GPIO_Pin_10
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); //GPIOC	
	GPIO_SetBits(GPIOC,GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5|GPIO_Pin_4|GPIO_Pin_3);
	
	GPIO_SetBits(GPIOD,GPIO_Pin_2);


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;	   //GPIO_Pin_0
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure); //	
	GPIO_SetBits(GPIOA,GPIO_Pin_0);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;	   //
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStructure); //	
	GPIO_SetBits(GPIOD,GPIO_Pin_2);


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	//  
	GPIO_Init(GPIOB, &GPIO_InitStructure); //GPIOB   B
	GPIO_SetBits(GPIOB,GPIO_Pin_All);	 
}

//===================================================================================================
/* : void LCD_RESET(void)
   :  LCD λ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================

void LCD_RESET(void)
{
	LCD_RST_SET;
	//delay_ms(50);
	LCD_RST_CLR;
	delay_ms(5);	
//	delay_ms(100);	
	LCD_RST_SET;
	delay_ms(500);
}

//===================================================================================================
/* : void LCD_Init(void)
   :  LCDгʼ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================
void LCD_Init(void)
{     										 
	LCD_GPIOInit();
 	LCD_RESET();
	delay_ms(200); //100ms--->2ms	   
	
// LCD_WR_REG(0x0b);
//         LCD_WR_DATA(0xff);
   
	//************* Start Initial Sequence **********//
	LCD_WR_REG(0x11); //Exit Sleep
	delay_ms(50);
	
	LCD_WR_REG(0x26); //Set Default Gamma
	LCD_WR_DATA(0x04);
	
	LCD_WR_REG(0xB1);//Set Frame Rate
	LCD_WR_DATA(0x0C);
	LCD_WR_DATA(0x14);
	
	LCD_WR_REG(0xC0); //Set VRH1[4:0] & VC[2:0] for VCI1 & GVDD
	LCD_WR_DATA(0x0C);
	LCD_WR_DATA(0x05);
	
	LCD_WR_REG(0xC1); //Set BT[2:0] for AVDD & VCL & VGH & VGL
	LCD_WR_DATA(0x02);//0x00
	
	LCD_WR_REG(0xC5); //Set VMH[6:0] & VML[6:0] for VOMH & VCOML
	LCD_WR_DATA(0x29);  //31  21  29
	LCD_WR_DATA(0x43);  //58   48  43
	
	LCD_WR_REG(0xC7);
	LCD_WR_DATA(0x40);
	
	LCD_WR_REG(0x3a); //Set Color Format
	LCD_WR_DATA(0x05);
	
	LCD_WR_REG(0x2A); //Set Column Address
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x7F);
	
	LCD_WR_REG(0x2B); //Set Page Address
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x9F);
	   
	LCD_WR_REG(0x36); //Set Scanning Direction
	LCD_WR_DATA(0xC0); //0xc8
	
	LCD_WR_REG(0xB7); //Set Source Output Direction
	LCD_WR_DATA(0x00);
	
	LCD_WR_REG(0xF2); //Enable Gamma bit
	LCD_WR_DATA(0x01);
	
	LCD_WR_REG(0xE0);
	LCD_WR_DATA(0x36);//p1
	LCD_WR_DATA(0x29);//p2
	LCD_WR_DATA(0x12);//p3
	LCD_WR_DATA(0x22);//p4
	LCD_WR_DATA(0x1C);//p5
	LCD_WR_DATA(0x15);//p6
	LCD_WR_DATA(0x42);//p7
	LCD_WR_DATA(0xB7);//p8
	LCD_WR_DATA(0x2F);//p9
	LCD_WR_DATA(0x13);//p10
	LCD_WR_DATA(0x12);//p11
	LCD_WR_DATA(0x0A);//p12
	LCD_WR_DATA(0x11);//p13
	LCD_WR_DATA(0x0B);//p14
	LCD_WR_DATA(0x06);//p15
	
	
	LCD_WR_REG(0xE1);
	LCD_WR_DATA(0x09);//p1
	LCD_WR_DATA(0x16);//p2
	LCD_WR_DATA(0x2D);//p3
	LCD_WR_DATA(0x0D);//p4
	LCD_WR_DATA(0x13);//p5
	LCD_WR_DATA(0x15);//p6
	LCD_WR_DATA(0x40);//p7
	LCD_WR_DATA(0x48);//p8
	LCD_WR_DATA(0x53);//p9
	LCD_WR_DATA(0x0C);//p10
	LCD_WR_DATA(0x1D);//p11
	LCD_WR_DATA(0x25);//p12
	LCD_WR_DATA(0x2E);//p13
	LCD_WR_DATA(0x34);//p14
	LCD_WR_DATA(0x39);//p15
	
	LCD_WR_REG(0x29); // Display On
	
//	LCD_WR_REG(0x2c);


}
//===================================================================================================
/* : void BlockWrite(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend) 
   :  趨ʾ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================

// void BlockWrite(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend) //
//{

	
 void BlockWrite(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend) //reentrant
{
	unsigned short w;
	unsigned short h;
	w=Xend-Xstart+1;
	h=Yend-Ystart+1;

	 LCD_WR_REG(0x2a);
	 LCD_WR_DATA((Xstart)>>8);
	 LCD_WR_DATA((Xstart));
	 LCD_WR_DATA((Xend)>>8);
	 LCD_WR_DATA(Xend);
	
		 LCD_WR_REG(0x2b);
	 LCD_WR_DATA((Ystart)>>8);
	 LCD_WR_DATA((Ystart));
	 LCD_WR_DATA((Yend)>>8);
	 LCD_WR_DATA(Yend);
	//{
//		LCD_CtrlWrite_ILI9326(0x02,(Xstart)>>8);
//		LCD_CtrlWrite_ILI9326(0x03,(Xstart));
//		LCD_CtrlWrite_ILI9326(0x04,(Xend)>>8);
//		LCD_CtrlWrite_ILI9326(0x05,(Xend));
//		LCD_CtrlWrite_ILI9326(0x06,(Ystart)>>8);
//		LCD_CtrlWrite_ILI9326(0x07,(Ystart));
//		LCD_CtrlWrite_ILI9326(0x08,(Yend)>>8);
//		LCD_CtrlWrite_ILI9326(0x09,(Yend)); 
		LCD_WR_REG(0x2c); 	
//	}

//}

}


//===================================================================================================
/* : void DispColor(unsigned int color)
   :  ôɫĻ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================
void DispColor(unsigned int color)
{
	unsigned int i,j;
	BlockWrite(0,COL-1,0,ROW-1);
	LCD_CS_CLR;
	LCD_RS_SET;
	LCD_RD_SET;
		for(i=0;i<ROW;i++)
		{
		    for(j=0;j<COL;j++)
			{    
				
				DATAOUT(color>>8);// MCU 8λ
				LCD_WR_CLR;
				LCD_WR_SET;
				DATAOUT(color);
				LCD_WR_CLR;
				LCD_WR_SET;
				
				/*
				DATAOUT(color);//MCU 16λ
				LCD_WR_CLR;
				LCD_WR_SET;*/
				

			}
		}
		 LCD_CS_SET;
//	}

}	

void DispBand(void)	 
{
	unsigned int i,j,k;
	//unsigned int color[8]={0x001f,0x07e0,0xf800,0x07ff,0xf81f,0xffe0,0x0000,0xffff};
	unsigned int color[8]={0xf800,0xf800,0x07e0,0x07e0,0x001f,0x001f,0xffff,0xffff};//0x94B2
	//unsigned int gray16[]={0x0000,0x1082,0x2104,0x3186,0x42,0x08,0x528a,0x630c,0x738e,0x7bcf,0x9492,0xa514,0xb596,0xc618,0xd69a,0xe71c,0xffff};

   	BlockWrite(0,COL-1,0,ROW-1);
    	
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;																									  

	for(i=0;i<8;i++)
	{
		for(j=0;j<ROW/8;j++)
		{
	        for(k=0;k<COL;k++)
			{
				DATAOUT(color[i]>>8);      
				LCD_WR_CLR; 
				LCD_WR_SET;  
   
				DATAOUT(color[i]); 
				LCD_WR_CLR; 
				LCD_WR_SET;  
			} 
		}
	}
	for(j=0;j<ROW%8;j++)
	{
        for(k=0;k<COL;k++)
		{
			DATAOUT(color[7]>>8);      
			LCD_WR_CLR; 
			LCD_WR_SET;  

			DATAOUT(color[7]); 
			LCD_WR_CLR; 
			LCD_WR_SET;  
		} 
	}
	
	LCD_CS_SET;
}

void DispFrame(void)
{
	unsigned int i,j;
	
	BlockWrite(0,COL-1,0,ROW-1);

	LCD_CS_CLR;
	LCD_RS_SET;
	LCD_RD_SET;
		
	DATAOUT(0xf8);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;
	for(i=0;i<COL-2;i++){DATAOUT(0xFF);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0xFF);LCD_WR_CLR;LCD_WR_SET;}
	DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x1f);LCD_WR_CLR;LCD_WR_SET;

	for(j=0;j<ROW-2;j++)
	{
		DATAOUT(0xf8);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;
		for(i=0;i<COL-2;i++){DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;}
		DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x1F);LCD_WR_CLR;LCD_WR_SET;
	}
	
	DATAOUT(0xf8);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;
	for(i=0;i<COL-2;i++){DATAOUT(0xFF);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0xFF);LCD_WR_CLR;LCD_WR_SET;}
	DATAOUT(0x00);LCD_WR_CLR;LCD_WR_SET;DATAOUT(0x1F);LCD_WR_CLR;LCD_WR_SET;
	
	LCD_CS_SET;
}

void DispGrayHor16(void)	 
{
	unsigned int i,j,k;

   	BlockWrite(0,COL-1,0,ROW-1);
    	
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;																									  

	for(i=0;i<ROW;i++)
	{
		for(j=0;j<COL%16;j++)
		{
			DATAOUT(0);
			LCD_WR_CLR;
			LCD_WR_SET; 

			DATAOUT(0);
			LCD_WR_CLR;
			LCD_WR_SET; 
		}
		
		for(j=0;j<16;j++)
		{
	        for(k=0;k<COL/16;k++)
			{		
				DATAOUT(((j*2)<<3)|((j*4)>>3));	
				LCD_WR_CLR;
				LCD_WR_SET; 
					 
				DATAOUT(((j*4)<<5)|(j*2));
				LCD_WR_CLR;
				LCD_WR_SET; 
			} 
		}
	}
	
	LCD_CS_SET;
}

void DispGrayHor32(void)	 
{
	unsigned int i,j,k;

   	BlockWrite(0,COL-1,0,ROW-1);
    	
	LCD_CS_CLR;
	LCD_RD_SET;
	LCD_RS_SET;																									  

	for(i=0;i<ROW;i++)
	{
		for(j=0;j<COL%32;j++)
		{
			DATAOUT(0);
			LCD_WR_CLR;
			LCD_WR_SET; 

			DATAOUT(0);
			LCD_WR_CLR;
			LCD_WR_SET; 
		}
		
		for(j=0;j<32;j++)
		{
	        for(k=0;k<COL/32;k++)
			{		
				DATAOUT((j<<3)|((j*2)>>3));	
				LCD_WR_CLR;
				LCD_WR_SET; 
					 
				DATAOUT(((j*2)<<5)|j;)
				LCD_WR_CLR;
				LCD_WR_SET; 
			} 
		}
	}
	
	LCD_CS_SET;
}

void DrawLine(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend,unsigned int color)
{
	unsigned int i,j;

	BlockWrite(Xstart,Xend,Ystart,Yend);

	for(i=Ystart;i<Yend+1;i++)
	{
		for(j=Xstart;j<Xend+1;j++)
		{
			WriteOneDot(color);
		}
	}
}

void DrawGird(unsigned int color)
{
	unsigned int i;

	for(i=15;i<ROW-1;i=i+16)
	{
		DrawLine(0,COL-1,i,i,color);

	}

	for(i=15;i<COL-1;i=i+16)
	{
		DrawLine(i,i,0,ROW-1,color);
	}

}


//===================================================================================================
/* : void DisPic(unsigned char *p)
   :  ʾ50X60ͼƬ
   ע
      2008-2018 ȨУؾ*/
//====================================================================================================
/*
void DisPic(unsigned char *p)
{
	unsigned int i,j;
	BlockWrite(50,96-1+50,60,173-1+60);
		LCD_CS_CLR;
		LCD_RS_SET;
		LCD_RD_SET;
	
		for(i=0;i<173;i++)
		{
		    for(j=0;j<96;j++)
			{    
			  
				DATAOUT((*p));
				LCD_WR_CLR;
				LCD_WR_SET;
				DATAOUT((*(p+1)));
				LCD_WR_CLR;
				LCD_WR_SET;
			  p=p+2;
			}
		}
		 LCD_CS_SET;

}	*/
