#ifndef __LCD_H
#define __LCD_H		
#include "sys.h"	


#define TP_TEST		    //TPʹܿ


//===================================================================================================
/*LCD ߶*/
//====================================================================================================
#define	LCD_CS_SET  	GPIOC->BSRR=1<<3    //Ƭѡ˿  	PC3
#define	LCD_RS_SET		GPIOC->BSRR=1<<4    ///   	PC4	   
#define	LCD_WR_SET		GPIOC->BSRR=1<<5    //д		PC5
#define	LCD_RD_SET		GPIOC->BSRR=1<<6    //		PC6
#define	LCD_RST_SET		GPIOC->BSRR=1<<7   //λ			PC7
							    
#define	LCD_CS_CLR  	GPIOC->BRR=1<<3     //Ƭѡ˿  	PC3
#define	LCD_RS_CLR		GPIOC->BRR=1<<4     ///  	PC4	   
#define	LCD_WR_CLR		GPIOC->BRR=1<<5     //д		PC5
#define	LCD_RD_CLR		GPIOC->BRR=1<<6     //		PC6
#define	LCD_RST_CLR		GPIOC->BRR=1<<7    //λ			PC7	

#define DATAOUT(x) 		GPIOB->ODR=x; 		//  B
#define DATAIN   			GPIOB->IDR;   		//

#define	LCD_PD_SET  	GPIOD->BSRR=1<<2    //Ƭѡ˿  	PC3

//#define DATAOUT(x) 		GPIOD->ODR=2; 		//  LED PD2

#define	TP_CS_CLR       GPIOA->BRR=1<<15 
#define	TP_PENIRQ_CLR   GPIOA->BRR=1<<8 
#define	TP_DOUT_CLR     GPIOC->BRR=1<<11 
#define	TP_DIN_CLR      GPIOC->BRR=1<<10 
#define	TP_DCLK_CLR     GPIOA->BRR=1<<14 

#define	TP_CS_SET        GPIOA->BSRR=1<<15 
#define	TP_PENIRQ_SET    GPIOA->BSRR=1<<8 
#define	TP_DOUT_SET      GPIOC->BSRR=1<<11 
#define	TP_DIN_SET       GPIOC->BSRR=1<<10 
#define	TP_DCLK_SET      GPIOA->BSRR=1<<14 

//////////////////////////////////////////////////////////////////////
//ɫ
#define WHITE       0xFFFF
#define BLACK      	0x0000	  
#define BLUE       	0x001F 
#define BRED        0XF81F
#define GRED 			 	0XFFE0
#define GBLUE			 	0X07FF
#define RED         0xF800
#define MAGENTA     0xF81F
#define GREEN       0x07E0
#define CYAN        0x7FFF
#define YELLOW      0xFFE0
#define BROWN 			0XBC40 //ɫ
#define BRRED 			0XFC07 //غɫ
#define GRAY  			0X8430 //ɫ
#define GRAY25      0xADB5
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 
 
#define LIGHTGREEN     	0X841F //ǳɫ
//#define LIGHTGRAY     0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 		0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE      	0XA651 //ǳɫ(мɫ)
#define LBBLUE          0X2B12 //ǳɫ(ѡĿķɫ)

#define X_min 0x0043		 //TPԷΧ
#define X_max 0x07AE
#define Y_min 0x00A1
#define Y_max 0x0759

//===================================================================================================
/*Ի*/
//====================================================================================================



  #ifdef  TP_TEST	
	#define DRAW_FUNCTION
	#define STRING_FUNCTION
	
	
#endif
	    															  
extern u16 BACK_COLOR, POINT_COLOR ;  
void LCD_Init(void);
void LCD_WR_REG(u16 data);
void LCD_WR_DATA(u16 data);
void DispColor(unsigned int color);
void BlockWrite(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend);
void LCD_GPIOInit(void);
void DispFrame(void);
void DispBand(void);
void DispGrayHor16(void);
void DispGrayHor32(void);
extern void TP_DrawLine(void);
void DrawGird(unsigned int color);
void PutPixel(unsigned int x,unsigned int y,unsigned int color);


#endif
 